#include "qwayland-qt-dmabuf-server-buffer.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWayland {
    qt_dmabuf_server_buffer::qt_dmabuf_server_buffer(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_dmabuf_server_buffer::qt_dmabuf_server_buffer(struct ::qt_dmabuf_server_buffer *obj)
        : m_qt_dmabuf_server_buffer(obj)
    {
        init_listener();
    }

    qt_dmabuf_server_buffer::qt_dmabuf_server_buffer()
        : m_qt_dmabuf_server_buffer(nullptr)
    {
    }

    qt_dmabuf_server_buffer::~qt_dmabuf_server_buffer()
    {
    }

    void qt_dmabuf_server_buffer::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_dmabuf_server_buffer = static_cast<struct ::qt_dmabuf_server_buffer *>(wl_registry_bind(registry, id, &qt_dmabuf_server_buffer_interface, version));
        init_listener();
    }

    void qt_dmabuf_server_buffer::init(struct ::qt_dmabuf_server_buffer *obj)
    {
        m_qt_dmabuf_server_buffer = obj;
        init_listener();
    }

    qt_dmabuf_server_buffer *qt_dmabuf_server_buffer::fromObject(struct ::qt_dmabuf_server_buffer *object)
    {
        if (wl_proxy_get_listener((struct ::wl_proxy *)object) != (void *)&m_qt_dmabuf_server_buffer_listener)
            return nullptr;
        return static_cast<qt_dmabuf_server_buffer *>(qt_dmabuf_server_buffer_get_user_data(object));
    }

    bool qt_dmabuf_server_buffer::isInitialized() const
    {
        return m_qt_dmabuf_server_buffer != nullptr;
    }

    const struct wl_interface *qt_dmabuf_server_buffer::interface()
    {
        return &::qt_dmabuf_server_buffer_interface;
    }

    void qt_dmabuf_server_buffer::dmabuf_server_buffer_server_buffer_created(struct ::qt_server_buffer *, int32_t , int32_t , int32_t , int32_t , int32_t , int32_t )
    {
    }

    void qt_dmabuf_server_buffer::handle_server_buffer_created(
        void *data,
        struct ::qt_dmabuf_server_buffer *object,
        struct ::qt_server_buffer *id,
        int32_t fd,
        int32_t width,
        int32_t height,
        int32_t stride,
        int32_t offset,
        int32_t fourcc_format)
    {
        Q_UNUSED(object);
        static_cast<qt_dmabuf_server_buffer *>(data)->dmabuf_server_buffer_server_buffer_created(
            id,
            fd,
            width,
            height,
            stride,
            offset,
            fourcc_format);
    }

    const struct qt_dmabuf_server_buffer_listener qt_dmabuf_server_buffer::m_qt_dmabuf_server_buffer_listener = {
        qt_dmabuf_server_buffer::handle_server_buffer_created
    };

    void qt_dmabuf_server_buffer::init_listener()
    {
        qt_dmabuf_server_buffer_add_listener(m_qt_dmabuf_server_buffer, &m_qt_dmabuf_server_buffer_listener, this);
    }
}

QT_WARNING_POP
QT_END_NAMESPACE
